#include <types.h>
#include <unistd.h>
#include <osbind.h>
#include <mintbind.h>
#include <errno.h>

extern int __mint;

int
setreuid(ruid,euid)
  int ruid, euid;
{
  long r;

  if (__mint) {
    if (__mint >= 0x10B) {
      r = Psetreuid(ruid, euid);
      if (r < 0) {
	errno = (int) -r;
	return -1;
      }
    } else {
      return (setuid (euid));
    }
  }
  return 0;
}

